## Tool: `get_deployment`

Get details about a deployment resource in the API hub.

The following sample demonstrate how to use `curl` to invoke the `get_deployment` MCP tool.

| Curl Request |
|---|
| ```bash curl --location 'https://apihub.googleapis.com/mcp' \ --header 'content-type: application/json' \ --header 'accept: application/json, text/event-stream' \ --data '{ "method": "tools/call", "params": { "name": "get_deployment", "arguments": { // provide these details according to the tool's MCP specification } }, "jsonrpc": "2.0", "id": 1 }' ``` |

## Input Schema

The `GetDeployment` method's request.

### GetDeploymentRequest

| JSON representation |
|---|
| ``` { "name": string } ``` |

| Fields ||
|---|---|
| `name` | `string` Required. The name of the deployment resource to retrieve. Format: `projects/{project}/locations/{location}/deployments/{deployment}` |

## Output Schema

Details of the deployment where APIs are hosted. A deployment could represent an Apigee proxy, API gateway, other Google Cloud services or non-Google Cloud services as well. A deployment entity is a root level entity in the API hub and exists independent of any API.

### Deployment

| JSON representation |
|---|
| ``` { "name": string, "displayName": string, "description": string, "documentation": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.Documentation`) }, "deploymentType": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AttributeValues`) }, "resourceUri": string, "endpoints": [ string ], "apiVersions": [ string ], "createTime": string, "updateTime": string, "slo": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AttributeValues`) }, "environment": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AttributeValues`) }, "attributes": { string: { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AttributeValues`) }, ... }, "sourceMetadata": [ { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.SourceMetadata`) } ], "managementUrl": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AttributeValues`) }, "sourceUri": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AttributeValues`) }, "sourceProject": string, "sourceEnvironment": string } ``` |

| Fields ||
|---|---|
| `name` | `string` Identifier. The name of the deployment. Format: `projects/{project}/locations/{location}/deployments/{deployment}` |
| `displayName` | `string` Required. The display name of the deployment. |
| `description` | `string` Optional. The description of the deployment. |
| `documentation` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.Documentation`)`` Optional. The documentation of the deployment. |
| `deploymentType` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AttributeValues`)`` Required. The type of deployment. This maps to the following system defined attribute: `projects/{project}/locations/{location}/attributes/system-deployment-type` attribute. The number of values for this attribute will be based on the cardinality of the attribute. The same can be retrieved via GetAttribute API. All values should be from the list of allowed values defined for the attribute. |
| `resourceUri` | `string` Required. The resource URI identifies the deployment within its gateway. For Apigee gateways, its recommended to use the format: organizations/{org}/environments/{env}/apis/{api}. For ex: if a proxy with name `orders` is deployed in `staging` environment of `cymbal` organization, the resource URI would be: `organizations/cymbal/environments/staging/apis/orders`. |
| `endpoints[]` | `string` Required. The endpoints at which this deployment resource is listening for API requests. This could be a list of complete URIs, hostnames or an IP addresses. |
| `apiVersions[]` | `string` Output only. The API versions linked to this deployment. Note: A particular deployment could be linked to multiple different API versions (of same or different APIs). |
| `createTime` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#timestamp` format)`` Output only. The time at which the deployment was created. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: `"2014-10-02T15:01:23Z"`, `"2014-10-02T15:01:23.045123456Z"` or `"2014-10-02T15:01:23+05:30"`. |
| `updateTime` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#timestamp` format)`` Output only. The time at which the deployment was last updated. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: `"2014-10-02T15:01:23Z"`, `"2014-10-02T15:01:23.045123456Z"` or `"2014-10-02T15:01:23+05:30"`. |
| `slo` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AttributeValues`)`` Optional. The SLO for this deployment. This maps to the following system defined attribute: `projects/{project}/locations/{location}/attributes/system-slo` attribute. The number of values for this attribute will be based on the cardinality of the attribute. The same can be retrieved via GetAttribute API. All values should be from the list of allowed values defined for the attribute. |
| `environment` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AttributeValues`)`` Optional. The environment mapping to this deployment. This maps to the following system defined attribute: `projects/{project}/locations/{location}/attributes/system-environment` attribute. The number of values for this attribute will be based on the cardinality of the attribute. The same can be retrieved via GetAttribute API. All values should be from the list of allowed values defined for the attribute. |
| `attributes` | ``map (key: string, value: object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AttributeValues`))`` Optional. The list of user defined attributes associated with the deployment resource. The key is the attribute name. It will be of the format: `projects/{project}/locations/{location}/attributes/{attribute}`. The value is the attribute values associated with the resource. An object containing a list of `"key": value` pairs. Example: `{ "name": "wrench", "mass": "1.3kg", "count": "3" }`. |
| `sourceMetadata[]` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.SourceMetadata`)`` Output only. The list of sources and metadata from the sources of the deployment. |
| `managementUrl` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AttributeValues`)`` Optional. The uri where users can navigate to for the management of the deployment. This maps to the following system defined attribute: `projects/{project}/locations/{location}/attributes/system-management-url` The number of values for this attribute will be based on the cardinality of the attribute. The same can be retrieved via GetAttribute API. The value of the attribute should be a valid URL. |
| `sourceUri` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AttributeValues`)`` Optional. The uri where additional source specific information for this deployment can be found. This maps to the following system defined attribute: `projects/{project}/locations/{location}/attributes/system-source-uri` The number of values for this attribute will be based on the cardinality of the attribute. The same can be retrieved via GetAttribute API. The value of the attribute should be a valid URI, and in case of Cloud Storage URI, it should point to a Cloud Storage object, not a directory. |
| `sourceProject` | `string` Optional. The project to which the deployment belongs. For Google Cloud gateways, this will refer to the project identifier. For others like Edge/OPDK, this will refer to the org identifier. |
| `sourceEnvironment` | `string` Optional. The environment at source for the deployment. For example: prod, dev, staging, etc. |

### Documentation

| JSON representation |
|---|
| ``` { "externalUri": string } ``` |

| Fields ||
|---|---|
| `externalUri` | `string` Optional. The uri of the externally hosted documentation. |

### AttributeValues

| JSON representation |
|---|
| ``` { "attribute": string, // Union field `Value` can be only one of the following: "enumValues": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.EnumAttributeValues`) }, "stringValues": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.StringAttributeValues`) }, "jsonValues": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.StringAttributeValues`) }, "uriValues": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.StringAttributeValues`) } // End of list of possible types for union field `Value`. } ``` |

| Fields ||
|---|---|
| `attribute` | `string` Output only. The name of the attribute. Format: projects/{project}/locations/{location}/attributes/{attribute} |
| Union field `Value`. The attribute values associated with the resource. `Value` can be only one of the following: ||
| `enumValues` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.EnumAttributeValues`)`` The attribute values associated with a resource in case attribute data type is enum. |
| `stringValues` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.StringAttributeValues`)`` The attribute values associated with a resource in case attribute data type is string. |
| `jsonValues` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.StringAttributeValues`)`` The attribute values associated with a resource in case attribute data type is JSON. |
| `uriValues` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.StringAttributeValues`)`` The attribute values associated with a resource in case attribute data type is URL, URI or IP, like gs://bucket-name/object-name. |

### EnumAttributeValues

| JSON representation |
|---|
| ``` { "values": [ { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AllowedValue`) } ] } ``` |

| Fields ||
|---|---|
| `values[]` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AllowedValue`)`` Required. The attribute values in case attribute data type is enum. |

### AllowedValue

| JSON representation |
|---|
| ``` { "id": string, "displayName": string, "description": string, "immutable": boolean } ``` |

| Fields ||
|---|---|
| `id` | `string` Required. The ID of the allowed value. \* If provided, the same will be used. The service will throw an error if the specified id is already used by another allowed value in the same attribute resource. \* If not provided, a system generated id derived from the display name will be used. In this case, the service will handle conflict resolution by adding a system generated suffix in case of duplicates. This value should be 4-63 characters, and valid characters are /\[a-z\]\[0-9\]-/. |
| `displayName` | `string` Required. The display name of the allowed value. |
| `description` | `string` Optional. The detailed description of the allowed value. |
| `immutable` | `boolean` Optional. When set to true, the allowed value cannot be updated or deleted by the user. It can only be true for System defined attributes. |

### StringAttributeValues

| JSON representation |
|---|
| ``` { "values": [ string ] } ``` |

| Fields ||
|---|---|
| `values[]` | `string` Required. The attribute values in case attribute data type is string or JSON. |

### Timestamp

| JSON representation |
|---|
| ``` { "seconds": string, "nanos": integer } ``` |

| Fields ||
|---|---|
| `seconds` | `string (https://developers.google.com/discovery/v1/type-format format)` Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be between -62135596800 and 253402300799 inclusive (which corresponds to 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z). |
| `nanos` | `integer` Non-negative fractions of a second at nanosecond resolution. This field is the nanosecond portion of the duration, not an alternative to seconds. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be between 0 and 999,999,999 inclusive. |

### AttributesEntry

| JSON representation |
|---|
| ``` { "key": string, "value": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AttributeValues`) } } ``` |

| Fields ||
|---|---|
| `key` | `string` |
| `value` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AttributeValues`)`` |

### SourceMetadata

| JSON representation |
|---|
| ``` { "sourceType": enum (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.SourceType`), "originalResourceId": string, "originalResourceCreateTime": string, "originalResourceUpdateTime": string, // Union field `source` can be only one of the following: "pluginInstanceActionSource": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.PluginInstanceActionSource`) } // End of list of possible types for union field `source`. } ``` |

| Fields ||
|---|---|
| `sourceType` | ``enum (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.SourceType`)`` Output only. The type of the source. |
| `originalResourceId` | `string` Output only. The unique identifier of the resource at the source. |
| `originalResourceCreateTime` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#timestamp` format)`` Output only. The time at which the resource was created at the source. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: `"2014-10-02T15:01:23Z"`, `"2014-10-02T15:01:23.045123456Z"` or `"2014-10-02T15:01:23+05:30"`. |
| `originalResourceUpdateTime` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#timestamp` format)`` Output only. The time at which the resource was last updated at the source. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: `"2014-10-02T15:01:23Z"`, `"2014-10-02T15:01:23.045123456Z"` or `"2014-10-02T15:01:23+05:30"`. |
| Union field `source`. The source of the resource. `source` can be only one of the following: ||
| `pluginInstanceActionSource` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.PluginInstanceActionSource`)`` Output only. The source of the resource is a plugin instance action. |

### PluginInstanceActionSource

| JSON representation |
|---|
| ``` { "pluginInstance": string, "actionId": string } ``` |

| Fields ||
|---|---|
| `pluginInstance` | `string` Output only. The resource name of the source plugin instance. Format is `projects/{project}/locations/{location}/plugins/{plugin}/instances/{instance}` |
| `actionId` | `string` Output only. The id of the plugin instance action. |

### SourceType

The possible types of the source.

| Enums ||
|---|---|
| `SOURCE_TYPE_UNSPECIFIED` | Source type not specified. |
| `PLUGIN` | Source type plugin. |

### Tool Annotations

Destructive Hint: ❌ \| Idempotent Hint: ✅ \| Read Only Hint: ✅ \| Open World Hint: ❌